// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;



int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	multiset<int> need;
	for (int i = 0; i < n; ++i) {
		int num = inf.readInt();
		need.insert(num);
	}

	auto check_outp = [&](auto& stream) {
		string outcome = stream.readToken("Yes|No");
		if (outcome == "No") {
			return make_pair(0, string());
		}

		string s = stream.readToken(format("[()]{%d}", n * 2));

		vector<int> st;
		multiset<int> cur;
		for (int i = 0; i < szof(s); ++i) {
			if (s[i] == '(') {
				st.push_back(i);
			} else {
				stream.ensuref(szof(st), "bracket sequence isn't balanced");
				cur.insert(i - st.back() - 1);
				st.pop_back();
			}
		}

		stream.ensuref(szof(st) == 0, "bracket sequence isn't correct");

		stream.ensuref(need == cur, "bracket sequence doesn't match set of distances");

		return make_pair(1, s);
	};

	auto jans = check_outp(ans);
	auto pans = check_outp(ouf);

	if (jans.ff && !pans.ff) {
		quitf(_wa, "participant didn't find solution, but jury did");
	}

	if (!jans.ff && pans.ff) {
		quitf(_fail, "jury didn't find solution, but participant did");
	}

	if (!pans.ff) {
		quitf(_ok, "no solution");
	}

	quitf(_ok, "solution found: %s", pans.ss.c_str());

	return 0;
}