// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

vector<int> build_bbs(int n) {
	vector<int> arr(n, 1);
	for (int i = 0; i < n; ++i) {
		arr.push_back(-1);
	}

	if (__testlib_opts.count("swaps")) {
		int q = opt<int>("swaps");
		for (int i = 0; i < q; ++i) {
			int a, b;
			while (true) {
				a = rnd.next(n * 2);
				b = rnd.next(n * 2);
				if (arr[a] != arr[b]) {
					break;
				}
			}
			swap(arr[a], arr[b]);
		}
	} else {
		shuffle(arr.begin(), arr.end());
	}

	vector<int> arr_pos;
	int bal = 0;
	int worst = 0;
	int maxv = 0;
	for (int i = 0; i < n * 2; ++i) {
		bal += arr[i];
		maxv = max(maxv, bal);
		if (bal < worst) {
			worst = bal;
			arr_pos = {i + 1};
		} else if (bal == worst) {
			arr_pos.push_back(i + 1);
		}
	}

	int r = arr_pos[rnd.next(szof(arr_pos))];

	rotate(arr.begin(), arr.begin() + r, arr.end());

	vector<int> st;
	vector<int> outp;
	for (int i = 0; i < n * 2; ++i) {
		if (arr[i] == 1) {
			st.push_back(i);
		} else {
			assert(szof(st));
			outp.push_back(i - st.back() - 1);
			st.pop_back();
		}
	}

	assert(!szof(st));

	shuffle(outp.begin(), outp.end());
	return outp;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);
	vector<int> outp;

	if (__testlib_opts.count("max_depth")) {
		int q = opt<int>("max_depth") + 1;
		vector<int> parts;
		int left = n;
		while (left) {
			int val = rnd.next(1, min(left, q));
			parts.push_back(val);
			left -= val;
		}

		for (int num : parts) {
			auto tmp = build_bbs(num);
			for (int x : tmp) {
				outp.push_back(x);
			}
		}
	} else {
		outp = build_bbs(n);
	}

	shuffle(outp.begin(), outp.end());
	cout << szof(outp) << "\n";
	for (int i = 0; i < n; ++i) {
		cout << outp[i];
		if (i < n - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	return 0;
}