// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	sort(arr.rbegin(), arr.rend());
	vector<char> dp(1 << n, -1);
	vector<string> res(1 << n);

	function<bool(int)> calc = [&](int mask) {
		if (mask == 0) {
			return true;
		}
		if (dp[mask] != -1) {
			return (bool) dp[mask];
		}
		int largest_ind = __builtin_ctz(mask);
		mask ^= 1 << largest_ind;
		for (int left = mask; ; left = (left - 1) & mask) {
			if (__builtin_popcount(left) * 2 == arr[largest_ind]) {
				if (calc(left) && calc(mask ^ left)) {
					res[mask | (1 << largest_ind)] = "(" + res[left] + ")" + res[mask ^ left];
					dp[mask | (1 << largest_ind)] = true;
					return true;
				}
			}
			if (left == 0) {
				break;
			}
		}
		dp[mask | (1 << largest_ind)] = false;
		return false;
	};

	if (!calc((1 << n) - 1)) {
		cout << "No\n";
	} else {
		cout << "Yes\n";
		cout << res[(1 << n) - 1] << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}