// Checker created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;



int main(int argc, char* argv[]) {
	setName("compare two outputs");
	registerTestlibCmd(argc, argv);

	int n = inf.readInt();
	vector<int> szs;

	for (int i = 0; i < n; ++i) {
		int sz = inf.readInt();
		szs.push_back(sz);
	}

	auto check_outp = [&](auto& stream) {
		string outcome = stream.readToken("Yes|No");
		if (outcome == "No") {
			return 0;
		}
		vector<vector<int>> field(szs.back(), vector<int>(szs.back()));
		for (int i = 0; i < szs.back(); ++i) {
			for (int j = 0; j < szs.back(); ++j) {
				field[i][j] = stream.readInt(1, szs.back());
			}
		}

		for (int sz : szs) {
			set<int> templ;
			bool fl = false;
			for (int i = 0; i < sz; ++i) {
				set<int> cur(field[i].begin(), field[i].begin() + sz);
				stream.ensuref(szof(cur) == sz, "square %dx%d, row #%d contains equal elements", sz, sz, i + 1);
				if (!fl) {
					templ = cur;
					fl = true;
				} else {
					stream.ensuref(cur == templ, "square %dx%d, rows #1 and #%d contains different values", sz, sz, i + 1);
				}

				cur.clear();
				for (int j = 0; j < sz; ++j) {
					cur.insert(field[j][i]);
				}
				stream.ensuref(szof(cur) == sz, "square %dx%d, column #%d contains equal elements", sz, sz, i + 1);
				stream.ensuref(cur == templ, "square %dx%d, row #1 and column #%d contains different values", sz, sz, i + 1);
			}
		}

		return 1;
	};

	int jans = check_outp(ans);
	int pans = check_outp(ouf);

	if (jans && !pans) {
		quitf(_wa, "participant didn't find solution, but jury did");
	}

	if (!jans && pans) {
		quitf(_fail, "jury didn't find solution, but participant did");
	}

	if (!pans) {
		quitf(_ok, "no solution");
	}

	quitf(_ok, "solution was found");

	return 0;
}