// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	for (int i = 0; i < n - 1; ++i) {
		if (arr[i] * 2 > arr[i + 1]) {
			cout << "No\n";
			return;
		}
	}

	vector<vector<int>> field;

	int prev = 0;

	for (int i = 0; i < n; ++i) {
		vector<vector<int>> new_field(arr[i], vector<int>(arr[i], -1));

		for (int j = 0; j < prev; ++j) {
			for (int k = 0; k < prev; ++k) {
				new_field[j][k] = field[j][k];
			}
		}

		for (int j = 0; j < arr[i] - prev; ++j) {
			for (int k = 0; k < prev; ++k) {
				new_field[prev + j][prev + (j + k) % (arr[i] - prev)] = k;
			}
		}

		vector<vector<int>> graph(arr[i]);
		vector<int> rl(arr[i], -1);

		for (int x = 0; x < arr[i]; ++x) {
			for (int y = 0; y < arr[i]; ++y) {
				if (new_field[x][y] == -1) {
					graph[x].push_back(y);
				}
			}
		}

		vector<bool> used(arr[i]);

		function<bool(int)> dfs = [&](int v) {
			used[v] = true;
			for (int to : graph[v]) {
				if (rl[to] == -1 || (!used[rl[to]] && dfs(rl[to]))) {
					rl[to] = v;
					return true;
				}
			}
			return false;
		};

		for (int j = prev; j < arr[i]; ++j) {
			fill(rl.begin(), rl.end(), -1);
			for (int k = 0; k < arr[i]; ++k) {
				fill(used.begin(), used.end(), 0);
				assert(dfs(k));
			}
			for (int k = 0; k < arr[i]; ++k) {
				new_field[rl[k]][k] = j;
				graph[rl[k]].erase(find(graph[rl[k]].begin(), graph[rl[k]].end(), k));
			}
		}

		prev = arr[i];
		swap(field, new_field);
	}

	cout << "Yes\n";

	for (int i = 0; i < arr[n - 1]; ++i) {
		for (int j = 0; j < arr[n - 1]; ++j) {
			cout << field[i][j] + 1 << " ";
		}
		cout << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}